import { Option } from './option';
import { IOption } from './option.interface';
export declare class OptionList<T> {
    private _options;
    private _highlightedOption;
    private _hasShown;
    private _hasSelected;
    readonly hasShown: boolean;
    readonly hasSelected: boolean;
    constructor(options: Array<IOption>);
    /** Options. **/
    readonly options: Array<Option<T>>;
    getOptionsByValue(value: T): Array<Option<T>>;
    /** Value. **/
    value: Array<T>;
    /** Selection. **/
    readonly selection: Array<Option<T>>;
    select(option: Option<T>, multiple: boolean): void;
    deselect(option: Option<T>): void;
    clearSelection(): void;
    private updateHasSelected();
    /** Filter. **/
    readonly filtered: Array<Option<T>>;
    readonly filteredEnabled: Array<Option<T>>;
    filter(term: string): boolean;
    private resetFilter();
    /** Highlight. **/
    readonly highlightedOption: Option<T>;
    highlight(): void;
    highlightOption(option: Option<T>): void;
    highlightNextOption(): void;
    highlightPreviousOption(): void;
    private clearHighlightedOption();
    private getHighlightedIndexFromList(options);
    getHighlightedIndex(): number;
    /** Util. **/
    hasShownSelected(): boolean;
    private getFirstShown();
    private getFirstShownSelected();
    static equalValues(v0: Array<string>, v1: Array<string>): boolean;
}
